#!/usr/bin/perl

# "accounts.pl", a script for use with the Forum News Gateway
# copyright 1995 by Swarthmore College

# List information about news gateway accounts, as stored in the
# accounts' Newsrc files.

unshift (@INC,"Scripts");		# get "require" files from Scripts directory
require "header.ph";			# for $Header1 and $Header2

unshift (@INC,".");				# get "require" files from parent directory
require "config.pl";			# for $UserFilesDirectoryName
require "files.pl";				# for &MyDBMOpen
require "time.pl";				# for &ShortTimeString

# --

$header = ($ARGV[0] ne "-n");

if (@ARGV > 1 || (@ARGV == 1 && $header)) {
	print STDERR "usage: perl $0 [-n]\n",
				 "    print information about newsreading accounts\n",
				 "    optional -n suppresses column headers\n";
	exit (1);
}

# --

# Get the list of account names.
opendir (ACCOUNTS, $UserFilesDirectoryName) || die "accounts.pl: can't open directory";
@accounts = readdir (ACCOUNTS);
closedir (ACCOUNTS);

# User accounts have alphanumeric names. Strip out files with initial ".".
# Theoretically, these should be only "." and "..".
@accounts = grep(!/^\./,@accounts);

if ($header) {
	print $Header1, $Header2;
}

foreach $account (@accounts) {
	%Newsrc = ();
	&MyDBMOpen (*Newsrc, "$UserFilesDirectoryName/$account/Newsrc") || die "can't open account $account";
	print $account,"\t",
		  $Newsrc{"prefs","realname"},"\t",
		  $Newsrc{"prefs","email"},"\t",
		  $Newsrc{"prefs","organization"},"\t",
		  &ShortTimeString($Newsrc{"time","created"}),"\t",
		  &ShortTimeString($Newsrc{"time","used"}),"\n";
}
